Index: branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/ArtificialClassificationDataDescriptor.cs
===================================================================
--- branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/ArtificialClassificationDataDescriptor.cs	(revision 8228)
+++ branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/ArtificialClassificationDataDescriptor.cs	(revision 9363)
@@ -29,5 +29,5 @@
 
     protected abstract string TargetVariable { get; }
-    protected abstract string[] InputVariables { get; }
+    protected abstract string[] VariableNames { get; }
     protected abstract string[] AllowedInputVariables { get; }
     protected abstract int TrainingPartitionStart { get; }
@@ -37,5 +37,5 @@
 
     public IClassificationProblemData GenerateClassificationData() {
-      Dataset dataset = new Dataset(InputVariables, this.GenerateValues());
+      Dataset dataset = new Dataset(VariableNames, this.GenerateValues());
 
       ClassificationProblemData claData = new ClassificationProblemData(dataset, AllowedInputVariables, TargetVariable);
Index: branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/CSV/ClassifiactionCSVInstanceProvider.cs
===================================================================
--- branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/CSV/ClassifiactionCSVInstanceProvider.cs	(revision 8228)
+++ branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/CSV/ClassifiactionCSVInstanceProvider.cs	(revision 9363)
@@ -21,8 +21,9 @@
 
 using System;
+using System.Collections;
 using System.Collections.Generic;
 using System.IO;
 using System.Linq;
-using System.Text;
+using HeuristicLab.Common;
 using HeuristicLab.Problems.DataAnalysis;
 
@@ -61,50 +62,120 @@
 
       Dataset dataset = new Dataset(csvFileParser.VariableNames, csvFileParser.Values);
-      string targetVar = csvFileParser.VariableNames.Where(x => dataset.DoubleVariables.Contains(x)).Last();
-      IEnumerable<string> allowedInputVars = dataset.DoubleVariables.Where(x => !x.Equals(targetVar));
+      string targetVar = dataset.DoubleVariables.Last();
 
-      ClassificationProblemData claData = new ClassificationProblemData(dataset, allowedInputVars, targetVar);
-
-      int trainingPartEnd = csvFileParser.Rows * 2 / 3;
-      claData.TrainingPartition.Start = 0;
-      claData.TrainingPartition.End = trainingPartEnd;
-      claData.TestPartition.Start = trainingPartEnd;
-      claData.TestPartition.End = csvFileParser.Rows;
-      int pos = path.LastIndexOf('\\');
-      if (pos < 0)
-        claData.Name = path;
-      else {
-        pos++;
-        claData.Name = path.Substring(pos, path.Length - pos);
+      // turn of input variables that are constant in the training partition
+      var allowedInputVars = new List<string>();
+      var trainingIndizes = Enumerable.Range(0, (csvFileParser.Rows * 2) / 3);
+      if (trainingIndizes.Count() >= 2) {
+        foreach (var variableName in dataset.DoubleVariables) {
+          if (dataset.GetDoubleValues(variableName, trainingIndizes).Range() > 0 &&
+            variableName != targetVar)
+            allowedInputVars.Add(variableName);
+        }
+      } else {
+        allowedInputVars.AddRange(dataset.DoubleVariables.Where(x => !x.Equals(targetVar)));
       }
 
-      return claData;
+      ClassificationProblemData classificationData = new ClassificationProblemData(dataset, allowedInputVars, targetVar);
+
+      int trainingPartEnd = trainingIndizes.Last();
+      classificationData.TrainingPartition.Start = trainingIndizes.First();
+      classificationData.TrainingPartition.End = trainingPartEnd;
+      classificationData.TestPartition.Start = trainingPartEnd;
+      classificationData.TestPartition.End = csvFileParser.Rows;
+
+      classificationData.Name = Path.GetFileName(path);
+
+      return classificationData;
     }
 
-    public override bool CanExportData {
-      get { return true; }
-    }
-    public override void ExportData(IClassificationProblemData instance, string path) {
-      StringBuilder strBuilder = new StringBuilder();
-
-      foreach (var variable in instance.InputVariables) {
-        strBuilder.Append(variable + ";");
-      }
-      strBuilder.Remove(strBuilder.Length - 1, 1);
-      strBuilder.AppendLine();
-
-      Dataset dataset = instance.Dataset;
-
-      for (int i = 0; i < dataset.Rows; i++) {
-        for (int j = 0; j < dataset.Columns; j++) {
-          strBuilder.Append(dataset.GetValue(i, j) + ";");
+    protected override IClassificationProblemData ImportData(string path, ClassificationImportType type, TableFileParser csvFileParser) {
+      int trainingPartEnd = (csvFileParser.Rows * type.TrainingPercentage) / 100;
+      List<IList> values = csvFileParser.Values;
+      if (type.Shuffle) {
+        values = Shuffle(values);
+        if (type.UniformlyDistributeClasses) {
+          values = Shuffle(values, csvFileParser.VariableNames.ToList().FindIndex(x => x.Equals(type.TargetVariable)),
+                           type.TrainingPercentage, out trainingPartEnd);
         }
-        strBuilder.Remove(strBuilder.Length - 1, 1);
-        strBuilder.AppendLine();
       }
 
-      using (StreamWriter writer = new StreamWriter(path)) {
-        writer.Write(strBuilder);
+      Dataset dataset = new Dataset(csvFileParser.VariableNames, values);
+
+      // turn of input variables that are constant in the training partition
+      var allowedInputVars = new List<string>();
+      var trainingIndizes = Enumerable.Range(0, trainingPartEnd);
+      if (trainingIndizes.Count() >= 2) {
+        foreach (var variableName in dataset.DoubleVariables) {
+          if (dataset.GetDoubleValues(variableName, trainingIndizes).Range() > 0 &&
+            variableName != type.TargetVariable)
+            allowedInputVars.Add(variableName);
+        }
+      } else {
+        allowedInputVars.AddRange(dataset.DoubleVariables.Where(x => !x.Equals(type.TargetVariable)));
       }
+
+      ClassificationProblemData classificationData = new ClassificationProblemData(dataset, allowedInputVars, type.TargetVariable);
+
+      classificationData.TrainingPartition.Start = 0;
+      classificationData.TrainingPartition.End = trainingPartEnd;
+      classificationData.TestPartition.Start = trainingPartEnd;
+      classificationData.TestPartition.End = csvFileParser.Rows;
+
+      classificationData.Name = Path.GetFileName(path);
+
+      return classificationData;
+    }
+
+    protected List<IList> Shuffle(List<IList> values, int target, int trainingPercentage, out int trainingPartEnd) {
+      IList targetValues = values[target];
+      var group = targetValues.Cast<double>().GroupBy(x => x).Select(g => new { Key = g.Key, Count = g.Count() }).ToList();
+      Dictionary<double, double> taken = new Dictionary<double, double>();
+      foreach (var classCount in group) {
+        taken[classCount.Key] = (classCount.Count * trainingPercentage) / 100.0;
+      }
+
+      List<IList> training = GetListOfIListCopy(values);
+      List<IList> test = GetListOfIListCopy(values);
+
+      for (int i = 0; i < targetValues.Count; i++) {
+        if (taken[(double)targetValues[i]] > 0) {
+          AddRow(training, values, i);
+          taken[(double)targetValues[i]]--;
+        } else {
+          AddRow(test, values, i);
+        }
+      }
+
+      trainingPartEnd = training.First().Count;
+
+      for (int i = 0; i < training.Count; i++) {
+        for (int j = 0; j < test[i].Count; j++) {
+          training[i].Add(test[i][j]);
+        }
+      }
+
+      return training;
+    }
+
+    private void AddRow(List<IList> destination, List<IList> source, int index) {
+      for (int i = 0; i < source.Count; i++) {
+        destination[i].Add(source[i][index]);
+      }
+    }
+
+    private List<IList> GetListOfIListCopy(List<IList> values) {
+      List<IList> newList = new List<IList>(values.Count);
+      foreach (IList t in values) {
+        if (t is List<double>)
+          newList.Add(new List<double>());
+        else if (t is List<DateTime>)
+          newList.Add(new List<DateTime>());
+        else if (t is List<string>)
+          newList.Add(new List<string>());
+        else
+          throw new InvalidOperationException();
+      }
+      return newList;
     }
   }
Index: branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/ClassificationDataDescriptor.cs
===================================================================
--- branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/ClassificationDataDescriptor.cs	(revision 9363)
+++ branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/ClassificationDataDescriptor.cs	(revision 9363)
@@ -0,0 +1,48 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+using HeuristicLab.Problems.DataAnalysis;
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public abstract class ClassificationDataDescriptor : IDataDescriptor {
+    public abstract string Name { get; }
+    public abstract string Description { get; }
+
+    protected abstract string TargetVariable { get; }
+    protected abstract string[] VariableNames { get; }
+    protected abstract string[] AllowedInputVariables { get; }
+    protected abstract int TrainingPartitionStart { get; }
+    protected abstract int TrainingPartitionEnd { get; }
+    protected abstract int TestPartitionStart { get; }
+    protected abstract int TestPartitionEnd { get; }
+
+    public IClassificationProblemData GenerateClassificationData(Dataset dataset) {
+      IClassificationProblemData claData = new ClassificationProblemData(dataset, AllowedInputVariables, TargetVariable);
+      claData.Name = this.Name;
+      claData.Description = this.Description;
+      claData.TrainingPartition.Start = this.TrainingPartitionStart;
+      claData.TrainingPartition.End = this.TrainingPartitionEnd;
+      claData.TestPartition.Start = this.TestPartitionStart;
+      claData.TestPartition.End = this.TestPartitionEnd;
+      return claData;
+    }
+  }
+}
Index: branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/ClassificationImportType.cs
===================================================================
--- branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/ClassificationImportType.cs	(revision 9363)
+++ branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/ClassificationImportType.cs	(revision 9363)
@@ -0,0 +1,27 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion;
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class ClassificationImportType : DataAnalysisImportType {
+    public string TargetVariable { get; set; }
+    public bool UniformlyDistributeClasses { get; set; }
+  }
+}
Index: branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/ClassificationInstanceProvider.cs
===================================================================
--- branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/ClassificationInstanceProvider.cs	(revision 8228)
+++ branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/ClassificationInstanceProvider.cs	(revision 9363)
@@ -23,5 +23,5 @@
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  public abstract class ClassificationInstanceProvider : ProblemInstanceProvider<IClassificationProblemData> {
+  public abstract class ClassificationInstanceProvider : DataAnalysisInstanceProvider<IClassificationProblemData, ClassificationImportType> {
   }
 }
Index: branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/ResourceClassificationDataDescriptor.cs
===================================================================
--- branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/ResourceClassificationDataDescriptor.cs	(revision 8228)
+++ branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/ResourceClassificationDataDescriptor.cs	(revision 9363)
@@ -20,15 +20,13 @@
 #endregion
 
+using System.Collections.Generic;
+using System.Linq;
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  internal class ResourceClassificationDataDescriptor : IDataDescriptor {
-    public string Name { get; internal set; }
-    public string Description { get; internal set; }
+  public abstract class ResourceClassificationDataDescriptor : ClassificationDataDescriptor {
+    internal string ResourceName { get; set; }
 
-    internal string ResourceName { get; set; }
-    internal ResourceClassificationDataDescriptor(string name, string description, string resourceName) {
-      Name = name;
-      Description = description;
-      ResourceName = resourceName;
+    public bool CheckVariableNames(IEnumerable<string> VariableNames) {
+      return this.VariableNames.All(x => VariableNames.Contains(x));
     }
   }
Index: branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/ResourceClassificationInstanceProvider.cs
===================================================================
--- branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/ResourceClassificationInstanceProvider.cs	(revision 8228)
+++ branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/ResourceClassificationInstanceProvider.cs	(revision 9363)
@@ -21,5 +21,4 @@
 
 using System;
-using System.Collections.Generic;
 using System.Globalization;
 using System.IO;
@@ -34,20 +33,4 @@
 
     protected abstract string FileName { get; }
-
-    public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
-      var solutionsArchiveName = GetResourceName(FileName + @"\.zip");
-      if (!String.IsNullOrEmpty(solutionsArchiveName)) {
-        using (var solutionsZipFile = new ZipInputStream(GetType().Assembly.GetManifestResourceStream(solutionsArchiveName))) {
-          IList<string> entries = new List<string>();
-          ZipEntry curEntry;
-          while ((curEntry = solutionsZipFile.GetNextEntry()) != null) {
-            entries.Add(curEntry.Name);
-          }
-          foreach (var entry in entries.OrderBy(x => x)) {
-            yield return new ResourceClassificationDataDescriptor(Path.GetFileNameWithoutExtension(entry), Description, entry);
-          }
-        }
-      }
-    }
 
     public override IClassificationProblemData LoadData(IDataDescriptor id) {
@@ -70,18 +53,9 @@
 
         Dataset dataset = new Dataset(csvFileParser.VariableNames, csvFileParser.Values);
-        string targetVar = csvFileParser.VariableNames.Where(x => dataset.DoubleVariables.Contains(x)).Last();
-        IEnumerable<string> allowedInputVars = dataset.DoubleVariables.Where(x => !x.Equals(targetVar));
+        if (!descriptor.CheckVariableNames(csvFileParser.VariableNames)) {
+          throw new ArgumentException("Parsed file contains variables which are not in the descriptor.");
+        }
 
-        ClassificationProblemData claData = new ClassificationProblemData(dataset, allowedInputVars, targetVar);
-
-        int trainingPartEnd = csvFileParser.Rows * 2 / 3;
-        claData.TrainingPartition.Start = 0;
-        claData.TrainingPartition.End = trainingPartEnd;
-        claData.TestPartition.Start = trainingPartEnd;
-        claData.TestPartition.End = csvFileParser.Rows;
-
-        claData.Name = descriptor.Name;
-        claData.Description = descriptor.Description;
-        return claData;
+        return descriptor.GenerateClassificationData(dataset);
       }
     }
Index: branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Iris.cs
===================================================================
--- branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Iris.cs	(revision 9363)
+++ branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Iris.cs	(revision 9363)
@@ -0,0 +1,59 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+using System;
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class Iris : UCIDataDescriptor {
+    public override string Filename { get { return "Iris"; } }
+    public override string Description {
+      get {
+        return "Data Set Information:" + Environment.NewLine
+        + "This is perhaps the best known database to be found in the pattern " + Environment.NewLine
+        + "recognition literature. Fisher's paper is a classic in the field and "
+        + "is referenced frequently to this day. (See Duda & Hart, for example.) "
+        + "The data set contains 3 classes of 50 instances each, where each class "
+        + "refers to a type of iris plant. One class is linearly separable from the "
+        + "other 2; the latter are NOT linearly separable from each other." + Environment.NewLine
+        + "Predicted attribute: class of iris plant." + Environment.NewLine
+        + "This is an exceedingly simple domain." + Environment.NewLine + Environment.NewLine
+        + "The classes have been converted in the following way" + Environment.NewLine
+        + "Iris-setosa     = 0" + Environment.NewLine
+        + "Iris-versicolor = 1" + Environment.NewLine
+        + "Iris-virginica  = 2";
+      }
+    }
+    public override string Donor { get { return "M. Marshall"; } }
+    public override int Year { get { return 1988; } }
+
+    protected override string TargetVariable { get { return "class"; } }
+    protected override string[] VariableNames {
+      get { return new string[] { "sepal_length", "sepal_width", "petal_length", "petal_width", "class" }; }
+    }
+    protected override string[] AllowedInputVariables {
+      get { return new string[] { "sepal_length", "sepal_width", "petal_length", "petal_width" }; }
+    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return 100; } }
+    protected override int TestPartitionStart { get { return 100; } }
+    protected override int TestPartitionEnd { get { return 150; } }
+  }
+}
Index: branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Mammography.cs
===================================================================
--- branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Mammography.cs	(revision 9363)
+++ branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Mammography.cs	(revision 9363)
@@ -0,0 +1,63 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+using System;
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class Mammography : UCIDataDescriptor {
+    public override string Filename { get { return "Mammography"; } }
+    public override string Description {
+      get {
+        return "Data Set Information: Features are computed from a digitized image of a fine needle aspirate (FNA) of a breast mass."
+        + "Website: http://archive.ics.uci.edu/ml/datasets/Breast+Cancer+Wisconsin+%28Diagnostic%29" + Environment.NewLine
+        + "Attribute Information:" + Environment.NewLine
+        + "1) ID number" + Environment.NewLine
+        + "2) Diagnosis (M = malignant, B = benign)" + Environment.NewLine
+        + "3-32)" + Environment.NewLine + Environment.NewLine
+        + "Ten real-valued features are computed for each cell nucleus:" + Environment.NewLine + Environment.NewLine
+        + "a) radius (mean of distances from center to points on the perimeter)" + Environment.NewLine
+        + "b) texture (standard deviation of gray-scale values)" + Environment.NewLine
+        + "c) perimeter" + Environment.NewLine
+        + "d) area" + Environment.NewLine
+        + "e) smoothness (local variation in radius lengths)" + Environment.NewLine
+        + "f) compactness (perimeter^2 / area - 1.0)" + Environment.NewLine
+        + "g) concavity (severity of concave portions of the contour)" + Environment.NewLine
+        + "h) concave points (number of concave portions of the contour)" + Environment.NewLine
+        + "i) symmetry" + Environment.NewLine
+        + "j) fractal dimension (\"coastline approximation\" - 1)";
+      }
+    }
+    public override string Donor { get { return "M. Elter"; } }
+    public override int Year { get { return 2007; } }
+
+    protected override string TargetVariable { get { return "Severity"; } }
+    protected override string[] VariableNames {
+      get { return new string[] { "BI-RADS", "Age", "Shape", "Margin", "Density", "Severity" }; }
+    }
+    protected override string[] AllowedInputVariables {
+      get { return new string[] { "BI-RADS", "Age", "Shape", "Margin", "Density" }; }
+    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return 641; } }
+    protected override int TestPartitionStart { get { return 641; } }
+    protected override int TestPartitionEnd { get { return 961; } }
+  }
+}
Index: branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Parkinson.cs
===================================================================
--- branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Parkinson.cs	(revision 9363)
+++ branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Parkinson.cs	(revision 9363)
@@ -0,0 +1,57 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class Parkinson : UCIDataDescriptor {
+    public override string Filename { get { return "Parkinson"; } }
+    public override string Description {
+      get {
+        return "Data Set Information:" + Environment.NewLine
+        + "This dataset is composed of a range of biomedical voice measurements from 31 people, 23 with "
+        + "Parkinson's disease (PD). Each column in the table is a particular voice measure, and each row "
+        + "corresponds one of 195 voice recording from these individuals (\"name\" column). The main aim of "
+        + "the data is to discriminate healthy people from those with PD, according to \"status\" column which "
+        + "is set to 0 for healthy and 1 for PD." + Environment.NewLine
+        + "Further details are contained in the following reference -- if you use this dataset, please cite: " + Environment.NewLine
+        + "Max A. Little, Patrick E. McSharry, Eric J. Hunter, Lorraine O. Ramig (2008), 'Suitability of "
+        + "dysphonia measurements for telemonitoring of Parkinson's disease', IEEE Transactions on Biomedical "
+        + "Engineering (to appear)." + Environment.NewLine
+        + "Note: The column \"name\" has been removed and the column \"status\" has been moved to the end.";
+      }
+    }
+    public override string Donor { get { return "M. Little"; } }
+    public override int Year { get { return 2008; } }
+
+    protected override string TargetVariable { get { return "status"; } }
+    protected override string[] VariableNames {
+      get { return new string[] { "MDVP:Fo(Hz)", "MDVP:Fhi(Hz)", "MDVP:Flo(Hz)", "MDVP:Jitter(%)", "MDVP:Jitter(Abs)", "MDVP:RAP", "MDVP:PPQ", "Jitter:DDP", "MDVP:Shimmer", "MDVP:Shimmer(dB)", "Shimmer:APQ3", "Shimmer:APQ5", "MDVP:APQ", "Shimmer:DDA", "NHR", "HNR", "RPDE", "DFA", "spread1", "spread2", "D2", "PPE", "status" }; }
+    }
+    protected override string[] AllowedInputVariables {
+      get { return new string[] { "MDVP:Fo(Hz)", "MDVP:Fhi(Hz)", "MDVP:Flo(Hz)", "MDVP:Jitter(%)", "MDVP:Jitter(Abs)", "MDVP:RAP", "MDVP:PPQ", "Jitter:DDP", "MDVP:Shimmer", "MDVP:Shimmer(dB)", "Shimmer:APQ3", "Shimmer:APQ5", "MDVP:APQ", "Shimmer:DDA", "NHR", "HNR", "RPDE", "DFA", "spread1", "spread2", "D2", "PPE" }; }
+    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return 130; } }
+    protected override int TestPartitionStart { get { return 130; } }
+    protected override int TestPartitionEnd { get { return 195; } }
+  }
+}
Index: branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Thyroid.cs
===================================================================
--- branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Thyroid.cs	(revision 9363)
+++ branches/OaaS/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Thyroid.cs	(revision 9363)
@@ -0,0 +1,56 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+using System;
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class Thyroid : UCIDataDescriptor {
+    public override string Filename { get { return "Thyroid"; } }
+    public override string Description {
+      get {
+        return "Thyroid gland data. ('normal', hypo and hyper functioning)" + Environment.NewLine + Environment.NewLine +
+        "Attr. no :" + Environment.NewLine +
+        "1: Class attribute (1 = normal, 2 = hyper, 3 = hypo)" + Environment.NewLine +
+        "2: T3-resin uptake test. (A percentage)" + Environment.NewLine +
+        "3: Total Serum thyroxin as measured by the isotopic displacement method." + Environment.NewLine +
+        "4: Total serum triiodothyronine as measured by radioimmuno	assay." + Environment.NewLine +
+        "5: basal thyroid-stimulating hormone (TSH) as measured by radioimmuno assay." + Environment.NewLine +
+        "6: Maximal absolute difference of TSH value after injection of 200 micro grams of " +
+        "thyrotropin-releasing hormone as compared to the basal value." + Environment.NewLine +
+        "All attributes are continuous.";
+      }
+    }
+    public override string Donor { get { return "S. Aeberhard"; } }
+    public override int Year { get { return 1992; } }
+
+    protected override string TargetVariable { get { return "X000"; } }
+    protected override string[] VariableNames {
+      get { return new string[] { "X001", "X002", "X003", "X004", "X005", "X000" }; }
+    }
+    protected override string[] AllowedInputVariables {
+      get { return new string[] { "X001", "X002", "X003", "X004", "X005" }; }
+    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return 143; } }
+    protected override int TestPartitionStart { get { return 143; } }
+    protected override int TestPartitionEnd { get { return 215; } }
+  }
+}
